## weechat 4.0.1

=== debian/changelog ===
weechat (4.0.1-1) unstable; urgency=medium

  * New upstream release
  * Remove NEWS file, no longer required
  * Update build dependency from libncursesw5-dev to libncurses-dev
  * Bump Standards-Version to 4.6.2
  * Remove all patches (no longer required)

 -- Emmanuel Bouthenot <kolter@debian.org>  Tue, 04 Jul 2023 19:02:41 +0000

## weechat 4.0.5

=== CMakeLists.txt ===
#
# Copyright (C) 2003-2023 Sébastien Helleu <flashcode@flashtux.org>
# Copyright (C) 2007-2008 Julien Louis <ptitlouis@sysif.net>
# Copyright (C) 2008-2009 Emmanuel Bouthenot <kolter@openics.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.0)

project(weechat C)

# CMake options
set(CMAKE_VERBOSE_MAKEFILE OFF)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
set(CMAKE_SKIP_RPATH ON)

# compiler options
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char -fms-extensions -Wall -Wextra -Werror-implicit-function-declaration")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char -fms-extensions -Wall -Wextra")
if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
  # extra options specific to gcc/g++
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-overflow=2 -Wformat-truncation=2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat-overflow=2 -Wformat-truncation=2")
endif()

# version
execute_process(COMMAND "${CMAKE_SOURCE_DIR}/version.sh" devel-major OUTPUT_VARIABLE VERSION_MAJOR)
execute_process(COMMAND "${CMAKE_SOURCE_DIR}/version.sh" devel-minor OUTPUT_VARIABLE VERSION_MINOR)
execute_process(COMMAND "${CMAKE_SOURCE_DIR}/version.sh" devel-patch OUTPUT_VARIABLE VERSION_PATCH)
string(REGEX REPLACE "\n" "" VERSION_MAJOR "${VERSION_MAJOR}")
string(REGEX REPLACE "\n" "" VERSION_MINOR "${VERSION_MINOR}")
string(REGEX REPLACE "\n" "" VERSION_PATCH "${VERSION_PATCH}")
if(VERSION_PATCH STREQUAL "")
  set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}")
else()
  set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
endif()

# license
set(LICENSE "GPL3")

# add definitions for version and license
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0005 NEW)
  add_definitions(-DWEECHAT_VERSION="${VERSION}" -DWEECHAT_LICENSE="${LICENSE}")
else()
  add_definitions(-DWEECHAT_VERSION='"${VERSION}"' -DWEECHAT_LICENSE='"${LICENSE}"')
endif()

# package string
set(PKG_STRING "${PROJECT_NAME} ${VERSION}")
string(REPLACE "\";\"" "\ " PKG_STRING ${PKG_STRING})

if(NOT DEFINED LIBDIR)
  set(LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
endif()

if(NOT DEFINED WEECHAT_LIBDIR)
  set(WEECHAT_LIBDIR "${LIBDIR}/${PROJECT_NAME}")
endif()

if(NOT DEFINED DATAROOTDIR)
  set(DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/share")
endif()

if(NOT DEFINED WEECHAT_SHAREDIR)
  set(WEECHAT_SHAREDIR "${DATAROOTDIR}/weechat")
endif()

if(NOT DEFINED MANDIR)
  set(MANDIR "${DATAROOTDIR}/man")
endif()

if(NOT DEFINED LOCALEDIR)
  set(LOCALEDIR "${DATAROOTDIR}/locale")
endif()

if(DEFINED INCLUDEDIR)
  set(INCLUDEDIR "${INCLUDEDIR}/${PROJECT_NAME}")
else()
  set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME}")
endif()

option(ENABLE_NCURSES        "Compile the Ncurses interface"            ON)
option(ENABLE_HEADLESS       "Compile the headless binary"              ON)
option(ENABLE_NLS            "Enable Native Language Support"           ON)
option(ENABLE_LARGEFILE      "Enable Large File Support"                ON)
option(ENABLE_ALIAS          "Enable Alias plugin"                      ON)
option(ENABLE_BUFLIST        "Enable Buflist plugin"                    ON)
option(ENABLE_CHARSET        "Enable Charset plugin"                    ON)
option(ENABLE_EXEC           "Enable Exec plugin"                       ON)
option(ENABLE_FIFO           "Enable FIFO plugin"                       ON)
option(ENABLE_FSET           "Enable Fast Set plugin"                   ON)
option(ENABLE_IRC            "Enable IRC plugin"                        ON)
option(ENABLE_LOGGER         "Enable Logger plugin"                     ON)
option(ENABLE_RELAY          "Enable Relay plugin"                      ON)
option(ENABLE_SCRIPT         "Enable Script plugin (script manager)"    ON)
option(ENABLE_SCRIPTS        "Enable script plugins (perl, python, …)"  ON)
option(ENABLE_PERL           "Enable Perl scripting language"           ON)
option(ENABLE_PYTHON         "Enable Python scripting language"         ON)
option(ENABLE_RUBY           "Enable Ruby scripting language"           ON)
option(ENABLE_LUA            "Enable Lua scripting language"            ON)
option(ENABLE_TCL            "Enable Tcl scripting language"            ON)
option(ENABLE_GUILE          "Enable Scheme (guile) scripting language" ON)
option(ENABLE_JAVASCRIPT     "Enable JavaScript scripting language"     OFF)
option(ENABLE_PHP            "Enable PHP scripting language"            ON)
option(ENABLE_SPELL          "Enable Spell checker plugin"              ON)
option(ENABLE_ENCHANT        "Use Enchant lib in Spell checker plugin"  OFF)
option(ENABLE_TRIGGER        "Enable Trigger plugin"                    ON)
option(ENABLE_TYPING         "Enable Typing plugin"                     ON)
option(ENABLE_XFER           "Enable Xfer plugin"                       ON)
option(ENABLE_MAN            "Enable build of man page"                 OFF)
option(ENABLE_DOC            "Enable build of documentation"            OFF)
option(ENABLE_DOC_INCOMPLETE "Enable incomplete doc"                    OFF)
option(ENABLE_TESTS          "Enable tests"                             OFF)
option(ENABLE_CODE_COVERAGE  "Enable code coverage"                     OFF)

# code coverage
add_library(coverage_config INTERFACE)
if(ENABLE_CODE_COVERAGE)
  target_compile_options(coverage_config INTERFACE -O0 -g --coverage)
  target_link_libraries(coverage_config INTERFACE --coverage)
endif()

# headless mode is required for documentation
if(ENABLE_DOC AND NOT ENABLE_HEADLESS)
  message(FATAL_ERROR "Headless mode is required to build documentation.")
endif()

# all plugins (except javascript) are required for documentation
if(ENABLE_DOC AND NOT ENABLE_DOC_INCOMPLETE
    AND (NOT ENABLE_NLS OR NOT ENABLE_ALIAS OR NOT ENABLE_BUFLIST
      OR NOT ENABLE_CHARSET OR NOT ENABLE_EXEC OR NOT ENABLE_FIFO
      OR NOT ENABLE_FSET OR NOT ENABLE_IRC OR NOT ENABLE_LOGGER
      OR NOT ENABLE_RELAY OR NOT ENABLE_SCRIPT OR NOT ENABLE_SCRIPTS
      OR NOT ENABLE_PERL OR NOT ENABLE_PYTHON OR NOT ENABLE_RUBY
      OR NOT ENABLE_LUA OR NOT ENABLE_TCL OR NOT ENABLE_GUILE
      OR NOT ENABLE_PHP OR NOT ENABLE_SPELL OR NOT ENABLE_TRIGGER
      OR NOT ENABLE_TYPING OR NOT ENABLE_XFER))
  message(
    FATAL_ERROR
    " All plugins are required to build documentation.\n"
    " If you really want to build incomplete docs, enable this option:\n"
    "   -DENABLE_DOC_INCOMPLETE=ON"
  )
endif()

# headless mode is required for tests
if(ENABLE_TESTS AND NOT ENABLE_HEADLESS)
  message(FATAL_ERROR "Headless mode is required for tests.")
endif()

# option WEECHAT_HOME
set(WEECHAT_HOME "${WEECHAT_HOME}" CACHE
  STRING "Force a single WeeChat home directory for config, logs, scripts, etc."
  FORCE)
mark_as_advanced(CLEAR WEECHAT_HOME)

if(COMMAND cmake_policy)
  if(POLICY CMP0003)
    cmake_policy(SET CMP0003 NEW)
  endif()
  if(POLICY CMP0017)
    cmake_policy(SET CMP0017 NEW)
  endif()
endif()

add_definitions(-DHAVE_CONFIG_H)

include(FindPkgConfig)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)

check_include_files("langinfo.h" HAVE_LANGINFO_CODESET)
check_include_files("sys/resource.h" HAVE_SYS_RESOURCE_H)

check_function_exists(mallinfo HAVE_MALLINFO)
check_function_exists(mallinfo2 HAVE_MALLINFO2)

check_symbol_exists("eat_newline_glitch" "term.h" HAVE_EAT_NEWLINE_GLITCH)

# Check for Large File Support
if(ENABLE_LARGEFILE)
  add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE -D_LARGEFILE_SOURCE -D_LARGE_FILES)
endif()

# Check for Gettext
if(ENABLE_NLS)
  find_package(Gettext)
  if(GETTEXT_FOUND)
    add_definitions(-DENABLE_NLS)
    find_package(Intl)
    if(Intl_FOUND)
      list(APPEND EXTRA_LIBS "${Intl_LIBRARIES}")
    endif()
  else()
    message(SEND_ERROR "Gettext not found")
  endif()
endif()

# Check for libgcrypt
find_package(GCRYPT REQUIRED)
add_definitions(-DHAVE_GCRYPT)
list(APPEND EXTRA_LIBS ${GCRYPT_LDFLAGS})

# Check for GnuTLS
find_package(GnuTLS REQUIRED)
string(REGEX REPLACE "/[^/]*$" "" GNUTLS_LIBRARY_PATH "${GNUTLS_LIBRARY}")
include_directories(${GNUTLS_INCLUDE_PATH})
set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} -L${GNUTLS_LIBRARY_PATH}")
list(APPEND EXTRA_LIBS gnutls)

# Check for zlib
find_package(ZLIB REQUIRED)

# Check for zstd
pkg_check_modules(LIBZSTD REQUIRED libzstd)

# Check for iconv
find_package(Iconv)
if(ICONV_FOUND)
  add_definitions(-DHAVE_ICONV)
endif()

# Check for CURL
find_package(CURL REQUIRED)

# weechat_gui_common MUST be the first lib in the list
set(STATIC_LIBS weechat_gui_common)

find_library(DL_LIBRARY
  NAMES dl
  PATHS /lib /usr/lib /usr/libexec /usr/local/lib /usr/local/libexec
)
list(APPEND STATIC_LIBS weechat_plugins)
if(DL_LIBRARY)
  string(REGEX REPLACE "/[^/]*$" "" DL_LIBRARY_PATH "${DL_LIBRARY}")
  set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} -L${DL_LIBRARY_PATH}")
  list(APPEND EXTRA_LIBS dl)
endif()

add_subdirectory(icons)

if(ENABLE_NLS)
  add_subdirectory(po)
endif()

add_subdirectory(src)
add_subdirectory(doc)

if(ENABLE_TESTS)
  find_package(CppUTest)
  if(CPPUTEST_FOUND)
    enable_testing()
    add_subdirectory(tests)
  else()
    message(SEND_ERROR "CppUTest not found")
  endif()
else()
  enable_testing()
  add_test(NAME notests COMMAND true)
endif()

configure_file(config.h.cmake config.h @ONLY)

# set the git version in "config-git.h"
add_custom_target(version_git ALL
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/tools/set_git_version.sh" "${CMAKE_CURRENT_SOURCE_DIR}" "${VERSION}" "config-git.h"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY
)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
)

add_custom_target(dist
  "${CMAKE_CURRENT_SOURCE_DIR}/tools/makedist.sh" "${VERSION}" "HEAD" "${CMAKE_CURRENT_BINARY_DIR}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
)

# pkgconfig file
set(PACKAGE "${PROJECT_NAME}")
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
string(REPLACE "${CMAKE_INSTALL_PREFIX}" "\${prefix}" libdir "${LIBDIR}")
set(includedir "\${prefix}/include")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/weechat.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/weechat.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/weechat.pc" DESTINATION "${LIBDIR}/pkgconfig")

# cygport file (used to build Cygwin packages)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/weechat.cygport.in" "${CMAKE_CURRENT_BINARY_DIR}/weechat-${VERSION}-1.cygport" @ONLY)

# install some files (only on Cygwin)
if(CYGWIN)
  install(FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/Contributing.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/README.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ReleaseNotes.adoc"
    DESTINATION "${DATAROOTDIR}/doc/${PROJECT_NAME}"
  )
endif()

# desktop file
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/weechat.desktop" DESTINATION "${DATAROOTDIR}/applications")

=== po/CMakeLists.txt ===
#
# Copyright (C) 2003-2023 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

set(PO_FILES
  cs.po
  de.po
  es.po
  fr.po
  hu.po
  it.po
  ja.po
  pl.po
  pt.po
  pt_BR.po
  ru.po
  sr.po
  tr.po
)

set(BUGS_ADDRESS "flashcode@flashtux.org")
set(POT_FILE "${PROJECT_NAME}.pot")
set(POT_FILE_PATH "${CMAKE_CURRENT_BINARY_DIR}/${POT_FILE}")

include(srcfiles.cmake)

# Looking for xgettext, msgmerge and msgfmt
find_program(XGETTEXT_EXECUTABLE xgettext)
find_program(MSGMERGE_EXECUTABLE msgmerge)
find_program(MSGFMT_EXECUTABLE msgfmt)

if(XGETTEXT_EXECUTABLE AND MSGMERGE_EXECUTABLE AND MSGFMT_EXECUTABLE)

  # Create PO template file weechat.pot
  set(SRC_FILES)
  set(POT_DEPENDS)

  foreach(srcfile ${WEECHAT_SOURCES})
    set(SRC_FILES ${SRC_FILES} ${srcfile})
    set(POT_DEPENDS ${POT_DEPENDS} "${CMAKE_SOURCE_DIR}/${srcfile}")
  endforeach()

  add_custom_command(
    OUTPUT "${POT_FILE_PATH}"
    COMMAND "${XGETTEXT_EXECUTABLE}"
    ARGS -o "${POT_FILE_PATH}" --add-comments='TRANSLATORS:' --keyword='_' --keyword='weechat_gettext' --keyword='N_' --keyword='NG_:1,2' --keyword='weechat_ngettext:1,2' --no-location --from-code=UTF-8 --directory="${CMAKE_SOURCE_DIR}" --package-name='WeeChat' --package-version=${VERSION} --msgid-bugs-address=${BUGS_ADDRESS} --copyright-holder='NAME' ${SRC_FILES}
    DEPENDS ${POT_DEPENDS}
    COMMENT "Generating ${POT_FILE}"
  )

  set(MO_FILES)
  set(UPDATE_PO_TARGETS)
  foreach(pofile ${PO_FILES})
    get_filename_component(polang ${pofile} NAME_WE)

    # Compile .po files in build directory (to binary .mo files)
    set(modir "${CMAKE_CURRENT_BINARY_DIR}/${polang}/LC_MESSAGES")
    file(MAKE_DIRECTORY "${modir}")
    set(mofile "${modir}/${PROJECT_NAME}.mo")
    add_custom_command(
      OUTPUT "${mofile}"
      COMMAND "${MSGMERGE_EXECUTABLE}" ARGS --quiet -o "${CMAKE_CURRENT_BINARY_DIR}/${pofile}" "${CMAKE_CURRENT_SOURCE_DIR}/${pofile}" ${POT_FILE_PATH}
      COMMAND "${MSGFMT_EXECUTABLE}" ARGS -o "${mofile}" "${CMAKE_CURRENT_BINARY_DIR}/${pofile}"
      COMMAND "${MSGFMT_EXECUTABLE}" ARGS -c --statistics --verbose --output-file=/dev/null "${CMAKE_CURRENT_BINARY_DIR}/${pofile}"
      DEPENDS "${POT_FILE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/${pofile}"
      COMMENT "Compiling ${polang}.po"
    )

    # Update .po files in source directory (if needed)
    add_custom_target(
      update-${pofile}
      COMMAND "${MSGMERGE_EXECUTABLE}" --quiet --update --previous --backup=none "${CMAKE_CURRENT_SOURCE_DIR}/${pofile}" "${POT_FILE_PATH}"
      COMMENT "Updating ${polang}.po"
    )
    set(UPDATE_PO_TARGETS ${UPDATE_PO_TARGETS} update-${pofile})

    install(FILES "${mofile}" DESTINATION "${LOCALEDIR}/${polang}/LC_MESSAGES")
    set(MO_FILES ${MO_FILES} ${mofile})
  endforeach()

  add_custom_target(translations ALL DEPENDS ${MO_FILES})

  # Update weechat.pot in source directory (if needed)
  add_custom_target(
    update-${POT_FILE}
    COMMAND "${MSGMERGE_EXECUTABLE}" --quiet --update --backup=none "${CMAKE_CURRENT_SOURCE_DIR}/${POT_FILE}" "${POT_FILE_PATH}"
    COMMENT "Updating ${POT_FILE}"
  )

  # Update all .po and weechat.pot in source directory (if needed)
  add_custom_target(update-po DEPENDS update-${POT_FILE} ${UPDATE_PO_TARGETS})

endif()

=== tests/CMakeLists.txt ===
#
# Copyright (C) 2014-2023 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

enable_language(CXX)

remove_definitions(-DHAVE_CONFIG_H)
include_directories(${CPPUTEST_INCLUDE_DIRS} ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR})

# unit tests (core)
set(LIB_WEECHAT_UNIT_TESTS_CORE_SRC
  unit/core/test-core-arraylist.cpp
  unit/core/test-core-calc.cpp
  unit/core/test-core-command.cpp
  unit/core/test-core-config-file.cpp
  unit/core/test-core-crypto.cpp
  unit/core/test-core-dir.cpp
  unit/core/test-core-eval.cpp
  unit/core/test-core-hashtable.cpp
  unit/core/test-core-hdata.cpp
  unit/core/test-core-hook.cpp
  unit/core/test-core-infolist.cpp
  unit/core/test-core-list.cpp
  unit/core/test-core-network.cpp
  unit/core/test-core-secure.cpp
  unit/core/test-core-signal.cpp
  unit/core/test-core-string.cpp
  unit/core/test-core-url.cpp
  unit/core/test-core-utf8.cpp
  unit/core/test-core-util.cpp
  unit/gui/test-gui-bar.cpp
  unit/gui/test-gui-bar-item.cpp
  unit/gui/test-gui-bar-item-custom.cpp
  unit/gui/test-gui-bar-window.cpp
  unit/gui/test-gui-buffer.cpp
  unit/gui/test-gui-chat.cpp
  unit/gui/test-gui-color.cpp
  unit/gui/test-gui-filter.cpp
  unit/gui/test-gui-input.cpp
  unit/gui/test-gui-key.cpp
  unit/gui/test-gui-line.cpp
  unit/gui/test-gui-nick.cpp
  scripts/test-scripts.cpp
)
add_library(weechat_unit_tests_core STATIC ${LIB_WEECHAT_UNIT_TESTS_CORE_SRC})

# unit tests (plugins)
set(LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC unit/plugins/test-plugins.cpp)

if(ENABLE_ALIAS)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/alias/test-alias.cpp
  )
endif()

if(ENABLE_IRC)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/irc/test-irc-batch.cpp
    unit/plugins/irc/test-irc-buffer.cpp
    unit/plugins/irc/test-irc-channel.cpp
    unit/plugins/irc/test-irc-color.cpp
    unit/plugins/irc/test-irc-config.cpp
    unit/plugins/irc/test-irc-ignore.cpp
    unit/plugins/irc/test-irc-join.cpp
    unit/plugins/irc/test-irc-message.cpp
    unit/plugins/irc/test-irc-mode.cpp
    unit/plugins/irc/test-irc-nick.cpp
    unit/plugins/irc/test-irc-protocol.cpp
    unit/plugins/irc/test-irc-sasl.cpp
    unit/plugins/irc/test-irc-server.cpp
    unit/plugins/irc/test-irc-tag.cpp
  )
endif()

if(ENABLE_LOGGER)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/logger/test-logger.cpp
    unit/plugins/logger/test-logger-backlog.cpp
    unit/plugins/logger/test-logger-tail.cpp
  )
endif()

if (ENABLE_RELAY)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/relay/test-relay-auth.cpp
    unit/plugins/relay/irc/test-relay-irc.cpp
  )
endif()

if(ENABLE_TRIGGER)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/trigger/test-trigger.cpp
    unit/plugins/trigger/test-trigger-config.cpp
  )
endif()

if(ENABLE_TYPING)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/typing/test-typing.cpp
    unit/plugins/typing/test-typing-status.cpp
  )
endif()

if(ENABLE_XFER)
  list(APPEND LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC
    unit/plugins/xfer/test-xfer-file.cpp
    unit/plugins/xfer/test-xfer-network.cpp
  )
endif()

add_library(weechat_unit_tests_plugins MODULE ${LIB_WEECHAT_UNIT_TESTS_PLUGINS_SRC})

if(ICONV_LIBRARY)
  list(APPEND EXTRA_LIBS ${ICONV_LIBRARY})
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  list(APPEND EXTRA_LIBS "intl")
  if(HAVE_BACKTRACE)
    list(APPEND EXTRA_LIBS "execinfo")
  endif()
endif()

# binary to run tests
set(WEECHAT_TESTS_SRC
  tests.cpp tests.h
  tests-record.cpp tests-record.h
)
add_executable(tests ${WEECHAT_TESTS_SRC})
target_link_libraries(tests
  weechat_core
  weechat_plugins
  weechat_gui_common
  weechat_gui_headless
  weechat_ncurses_fake
  weechat_unit_tests_core
  # due to circular references, we must link two times with libweechat_core.a
  weechat_core
  ${EXTRA_LIBS}
  ${CURL_LIBRARIES}
  ${ZLIB_LIBRARY}
  ${LIBZSTD_LDFLAGS}
  ${CPPUTEST_LIBRARIES}
  -rdynamic
)
add_dependencies(tests
  weechat_core
  weechat_plugins
  weechat_gui_common
  weechat_gui_headless
  weechat_ncurses_fake
  weechat_unit_tests_core
)

# test for cmake (ctest)
add_test(NAME unit
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMAND tests -v
)
set_property(TEST unit PROPERTY
  ENVIRONMENT "WEECHAT_TESTS_ARGS=-p;"
  "WEECHAT_EXTRA_LIBDIR=${PROJECT_BINARY_DIR}/src;"
  "WEECHAT_TESTS_SCRIPTS_DIR=${CMAKE_CURRENT_SOURCE_DIR}/scripts/python;"
  "WEECHAT_TESTS_PLUGINS_LIB=${CMAKE_CURRENT_BINARY_DIR}/libweechat_unit_tests_plugins.so"
)

=== src/core/CMakeLists.txt ===
#
# Copyright (C) 2003-2023 Sébastien Helleu <flashcode@flashtux.org>
# Copyright (C) 2008 Julien Louis <ptitlouis@sysif.net>
# Copyright (C) 2009 Emmanuel Bouthenot <kolter@openics.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

set(LIB_CORE_SRC
  weechat.c weechat.h
  wee-arraylist.c wee-arraylist.h
  wee-backtrace.c wee-backtrace.h
  wee-calc.c wee-calc.h
  wee-command.c wee-command.h
  wee-completion.c wee-completion.h
  wee-config.c wee-config.h
  wee-config-file.c wee-config-file.h
  wee-crypto.c wee-crypto.h
  wee-debug.c wee-debug.h
  wee-dir.c wee-dir.h
  wee-doc.c wee-doc.h
  wee-eval.c wee-eval.h
  wee-hashtable.c wee-hashtable.h
  wee-hdata.c wee-hdata.h
  wee-hook.c wee-hook.h
  wee-infolist.c wee-infolist.h
  wee-input.c wee-input.h
  wee-list.c wee-list.h
  wee-log.c wee-log.h
  wee-network.c wee-network.h
  wee-proxy.c wee-proxy.h
  wee-secure.c wee-secure.h
  wee-secure-buffer.c wee-secure-buffer.h
  wee-secure-config.c wee-secure-config.h
  wee-signal.c wee-signal.h
  wee-string.c wee-string.h
  wee-upgrade.c wee-upgrade.h
  wee-upgrade-file.c wee-upgrade-file.h
  wee-url.c wee-url.h
  wee-utf8.c wee-utf8.h
  wee-util.c wee-util.h
  wee-version.c wee-version.h
  hook/wee-hook-command-run.c hook/wee-hook-command-run.h
  hook/wee-hook-command.c hook/wee-hook-command.h
  hook/wee-hook-completion.c hook/wee-hook-completion.h
  hook/wee-hook-config.c hook/wee-hook-config.h
  hook/wee-hook-connect.c hook/wee-hook-connect.h
  hook/wee-hook-fd.c hook/wee-hook-fd.h
  hook/wee-hook-focus.c hook/wee-hook-focus.h
  hook/wee-hook-hdata.c hook/wee-hook-hdata.h
  hook/wee-hook-hsignal.c hook/wee-hook-hsignal.h
  hook/wee-hook-info-hashtable.c hook/wee-hook-info-hashtable.h
  hook/wee-hook-info.c hook/wee-hook-info.h
  hook/wee-hook-infolist.c hook/wee-hook-infolist.h
  hook/wee-hook-line.c hook/wee-hook-line.h
  hook/wee-hook-modifier.c hook/wee-hook-modifier.h
  hook/wee-hook-print.c hook/wee-hook-print.h
  hook/wee-hook-process.c hook/wee-hook-process.h
  hook/wee-hook-signal.c hook/wee-hook-signal.h
  hook/wee-hook-timer.c hook/wee-hook-timer.h
)

# Check for flock support
include(CheckSymbolExists)
check_symbol_exists(flock "sys/file.h" HAVE_FLOCK)

if(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  find_library(EXECINFO_LIB_PATH execinfo /usr/local/lib)
  set(CMAKE_REQUIRED_LIBRARIES "${EXECINFO_LIB_PATH}")
  check_function_exists(backtrace HAVE_BACKTRACE)
else()
  check_symbol_exists(backtrace "execinfo.h" HAVE_BACKTRACE)
endif()

include_directories(${GNUTLS_INCLUDE_PATH})

include_directories(${CURL_INCLUDE_DIRS})

include_directories(${ZSTD_INCLUDE_DIRS})

include_directories("${CMAKE_BINARY_DIR}")
add_library(weechat_core STATIC ${LIB_CORE_SRC})
target_link_libraries(weechat_core coverage_config)
add_dependencies(weechat_core version_git)

=== src/plugins/perl/CMakeLists.txt ===
#
# Copyright (C) 2003-2023 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(perl MODULE
  weechat-perl.c weechat-perl.h
  weechat-perl-api.c weechat-perl-api.h
)
set_target_properties(perl PROPERTIES PREFIX "")

if(PERL_FOUND)
  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    # remove "-arch xxx" on macOS
    STRING(REGEX REPLACE "-arch ppc|-arch i386|-arch x86_64" "" PERL_CFLAGS "${PERL_CFLAGS}")
    STRING(REGEX REPLACE "-arch ppc|-arch i386|-arch x86_64" "" PERL_LFLAGS "${PERL_LFLAGS}")
  endif()
  add_definitions(${PERL_CFLAGS})
  include_directories(${PERL_INCLUDE_PATH})
  # ugly hack to force linking against Dynaloader.a
  string(REGEX MATCH "/[^ $]*/DynaLoader.a" PERL_DYNALOADER ${PERL_LFLAGS})
  if(PERL_DYNALOADER)
    string(REPLACE "${PERL_DYNALOADER}" "" PERL_LFLAGS "${PERL_LFLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${PERL_LFLAGS}")
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${PERL_DYNALOADER} ${CMAKE_CURRENT_BINARY_DIR}/libDynaLoader.a)
    target_link_libraries(perl ${PERL_LIBRARY} weechat_plugins_scripts ${CMAKE_CURRENT_BINARY_DIR}/libDynaLoader.a coverage_config)
  else()
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${PERL_LFLAGS}")
    target_link_libraries(perl ${PERL_LIBRARY} weechat_plugins_scripts coverage_config)
  endif()
endif()

install(TARGETS perl LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/plugins/trigger/CMakeLists.txt ===
#
# Copyright (C) 2014-2023 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(trigger MODULE
  trigger.c trigger.h
  trigger-buffer.c trigger-buffer.h
  trigger-callback.c trigger-callback.h
  trigger-command.c trigger-command.h
  trigger-completion.c trigger-completion.h
  trigger-config.c trigger-config.h
)
set_target_properties(trigger PROPERTIES PREFIX "")

target_link_libraries(trigger coverage_config)

install(TARGETS trigger LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== debian/changelog ===
weechat (4.0.5-1) unstable; urgency=medium

  * New upstream release

 -- Emmanuel Bouthenot <kolter@debian.org>  Sun, 24 Sep 2023 07:49:41 +0000

weechat (4.0.2-1) unstable; urgency=medium

  * New upstream release (Closes: #1040248)

 -- Emmanuel Bouthenot <kolter@debian.org>  Sat, 22 Jul 2023 05:48:35 +0000

=== debian/control ===
Source: weechat
Section: net
Priority: optional
Maintainer: Emmanuel Bouthenot <kolter@debian.org>
Build-Depends:
    asciidoctor (>= 1.5.4),
    debhelper (>= 13),
    debhelper-compat (= 13),
    cmake, pkg-config,
    libncurses-dev,
    ruby-dev,
    libperl-dev,
    python3-dev,
    libaspell-dev,
    liblua5.3-dev,
    tcl8.6-dev,
    guile-3.0-dev,
    php-dev, libphp-embed, libargon2-dev, libsodium-dev,
    libxml2-dev,
    libcurl4-gnutls-dev,
    libgcrypt20-dev,
    libgnutls28-dev,
    libzstd-dev,
    zlib1g-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://weechat.org/
Vcs-Git: https://salsa.debian.org/kolter/weechat.git
Vcs-Browser: https://salsa.debian.org/kolter/weechat

Package: weechat
Architecture: all
Depends:
    ${misc:Depends},
    weechat-curses (>= ${source:Version}) | weechat-headless (>= ${source:Version})
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client (metapackage)
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 It is customizable and extensible with plugins/scripts, and includes:
  - support of IRC protocol (native)
  - support of XMPP/Jabber protocol (with additional script)
  - nicklist
  - smart hotlist
  - horizontal and vertical split
  - double charset support (decode/encode)
  - FIFO pipe for remote control
  - 256 colors support
  - incremental text search
  - dynamic filtering of buffer content
  - Perl, Python, Ruby, Lua, Tcl, Scheme and PHP scripting
  - script manager
  - spell checking
  - highly customizable and extensible
  - and much more!

Package: weechat-curses
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-core (= ${binary:Version})
Recommends:
    weechat-plugins (= ${binary:Version})
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client - console client
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 It is customizable and extensible with plugins/scripts, and includes:
  - support of IRC protocol (native)
  - support of XMPP/Jabber protocol (with additional script)
  - nicklist
  - smart hotlist
  - horizontal and vertical split
  - double charset support (decode/encode)
  - FIFO pipe for remote control
  - 256 colors support
  - incremental text search
  - dynamic filtering of buffer content
  - Perl, Python, Ruby, Lua, Tcl, Scheme and PHP scripting
  - script manager
  - spell checking
  - highly customizable and extensible
  - and much more!
 .
 This package provides the console client (ncurses).

Package: weechat-headless
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-core (= ${binary:Version})
Recommends: weechat-plugins (= ${binary:Version})
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client - headless client
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 It is customizable and extensible with plugins/scripts, and includes:
  - support of IRC protocol (native)
  - support of XMPP/Jabber protocol (with additional script)
  - nicklist
  - smart hotlist
  - horizontal and vertical split
  - double charset support (decode/encode)
  - FIFO pipe for remote control
  - 256 colors support
  - incremental text search
  - dynamic filtering of buffer content
  - Perl, Python, Ruby, Lua, Tcl, Scheme and PHP scripting
  - script manager
  - spell checking
  - highly customizable and extensible
  - and much more!
 .
 This package provides the headless client.

Package: weechat-core
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends}
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client - core files
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides core plugins and locales files for WeeChat. It
 currently ships the following plugins: alias, buflist, charset, fset, irc,
 logger and xfer. It is useless without weechat-curses or weechat-headless.

Package: weechat-plugins
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Recommends:
    weechat-perl,
    weechat-python,
    weechat-ruby
Suggests: weechat-scripts (>> 20090221-1)
Description: Fast, light and extensible chat client - plugins
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides some plugins to enhance WeeChat. It currently
 ships the following plugins:
  - script manager
  - Spell checking (thanks to aspell)
  - FIFO pipe for remote control
  - Relay (IRC proxy and WeeChat protocol)
  - Trigger
  - Typing

Package: weechat-python
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Python 3 plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Python 3 scripting API plugin.

Package: weechat-perl
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Perl plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Perl scripting API plugin.

Package: weechat-ruby
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Ruby plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Ruby scripting API plugin.

Package: weechat-lua
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Lua plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Lua scripting API plugin.

Package: weechat-tcl
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Tcl plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Tcl scripting API plugin.

Package: weechat-guile
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Guile plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Guile scripting API plugin.

Package: weechat-php
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version}),
    libphp-embed
Description: Fast, light and extensible chat client - PHP plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the PHP scripting API plugin.

Package: weechat-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Fast, light and extensible chat client - documentation
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package contains the html documentation for WeeChat.

Package: weechat-dev
Section: devel
Architecture: any
Depends: ${misc:Depends}
Description: Fast, light and extensible chat client - development headers
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package contains the headers needed to build plugins.
